Imports System
Imports System.Data
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.Text
Imports System.Collections.Generic
Imports ASPNET.StarterKit.BusinessLogicLayer

Partial Public Class Report_Project_aspx
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load

        If (Not Page.IsPostBack) Then
            If Page.User.IsInRole("ProjectAdministrator") Then
                ProjectData.SelectMethod = "GetAllProjects"
            Else
                ProjectData.SelectParameters.Add(New Parameter("userName", TypeCode.String, Page.User.Identity.Name))
                ProjectData.SelectParameters.Add(New Parameter("sortParameter", TypeCode.String, String.Empty))
                ProjectData.SelectMethod = "GetProjectsByManagerUserName"
            End If
            ProjectList.DataBind()
        End If

    End Sub

    Protected Function BuildValueList(ByVal items As ListItemCollection, ByVal itemMustBeSelected As Boolean) As String

        Dim idList As StringBuilder = New StringBuilder()

        For Each item As ListItem In items
            If itemMustBeSelected AndAlso (Not item.Selected) Then
                Continue For
            Else
                idList.Append(item.Value.ToString())
                idList.Append(",")
            End If
        Next item
        Return idList.ToString()

    End Function

    Protected Sub GenProjectRpt_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GenProjectRpt.Click

        ProjectListRequiredFieldValidator.Validate()
        If ProjectListRequiredFieldValidator.IsValid Then
            Session.Add("SelectedProjectIds", BuildValueList(ProjectList.Items, True))
            Response.Redirect("Report_Project_Result.aspx")
        End If

    End Sub

End Class
